---
# {{ ansible_managed }}
version: '3.4'

x-metamigo-vars: &common-metamigo-variables
{% if not zammad_standalone %}
  CFACCESS_DOMAIN: "{{ metamigo_cloudflare_access_domain }}"
  CFACCESS_AUDIENCE: "{{ metamigo_cloudflare_access_audience }}"
{% endif %}
  DATABASE_HOST: "{{ metamigo_db_host }}"
  DATABASE_NAME: "{{ metamigo_db_name }}"
  DATABASE_ROOT_OWNER: "{{ metamigo_root_db_username }}"
  DATABASE_ROOT_PASSWORD: "{{ metamigo_root_db_password }}"
  DATABASE_OWNER: "{{ metamigo_db_username }}"
  DATABASE_PASSWORD: "{{ metamigo_db_password }}"
  DATABASE_VISITOR: "{{ database_visitor_username }}"
  DATABASE_AUTHENTICATOR: "{{ database_authenticator_username }}"
  DATABASE_AUTHENTICATOR_PASSWORD: "{{ database_authenticator_password }}"
  DATABASE_URL: "postgresql://{{ metamigo_db_username }}:{{ metamigo_db_password }}@{{ metamigo_db_host }}/{{ metamigo_db_name }}"
  WORKER_DATABASE_URL: "postgresql://{{ metamigo_db_username }}:{{ metamigo_db_password }}@{{ metamigo_db_host }}/{{ metamigo_db_name }}"
  SHADOW_DATABASE_URL: "postgresql://{{ metamigo_db_username }}:{{ metamigo_db_password }}@{{ metamigo_db_host }}/{{ metamigo_db_name}}_shadow"
  ROOT_DATABASE_URL: "postgresql://{{ metamigo_db_username }}:{{ metamigo_db_password }}@{{ metamigo_db_host}}/template1"
  APP_ROOT_DATABASE_URL: "postgresql://{{ metamigo_root_db_username }}:{{ metamigo_root_db_password }}@{{ metamigo_db_host }}/{{ metamigo_db_name }}"
  DATABASE_AUTH_URL: "postgresql://{{ database_authenticator_username }}:{{ database_authenticator_password }}@{{ metamigo_db_host }}/{{ metamigo_db_name }}"
  CORS_ALLOWED_ORIGINS: "https://{{ metamigo_api_domain }},https://{{ metamigo_frontend_domain }},http://localhost:3000,http://127.0.0.1:3000"
  FRONTEND_URL: "https://{{ metamigo_frontend_domain }}"
  API_URL: "http://metamigo-api:3001"
  NEXTAUTH_SECRET: "{{ nextauth_secret }}"
  NEXTAUTH_AUDIENCE: "{{ nextauth_audience }}"
  NEXTAUTH_SIGNING_KEY_B64: "{{ nextauth_signing_key }}"
  NEXTAUTH_ENCRYPTION_KEY_B64: "{{ nextauth_encryption_key }}"
  GOOGLE_ID: "{{ google_id }}"
  GOOGLE_SECRET: "{{ google_secret }}"
  SIGNALD_ENABLED: "true"
  SIGNALD_SOCKET: /signald/signald.sock
  LEAFCUTTER_ENABLED: "{{ leafcutter_enabled | bool | ternary('true', 'false') }}"
{% if leafcutter_enabled %}
  ZAMMAD_API_URL: "{{ leafcutter_zammad_api_url }}"
  ZAMMAD_API_KEY: "{{ leafcutter_zammad_api_key }}"
  LABEL_STUDIO_API_URL: "{{ leafcutter_label_studio_api_url }}"
  LABEL_STUDIO_API_KEY: "{{ leafcutter_label_studio_api_key }}"
  LEAFCUTTER_CONTRIBUTOR_ID: "{{ leafcutter_contributor_id }}"
  LEAFCUTTER_CONTRIBUTOR_NAME: "{{ leafcutter_contributor_name }}"
  OPENSEARCH_API_URL: "{{ leafcutter_opensearch_api_url }}"
  OPENSEARCH_USERNAME: "{{ leafcutter_opensearch_username }}"
  OPENSEARCH_PASSWORD: "{{ leafcutter_opensearch_password }}"
{% endif %}
x-logging: &default-logging
  options:
    max-size: '100m'
    max-file: '25'
    mode: non-blocking
  driver: json-file

services:
  zammad-nginx:
    image: "{{ zammad_image_zammad }}"
    command: ["zammad-nginx"]
    depends_on:
      - zammad-railsserver
      - zammad-websocket
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - zammad-data:/opt/zammad
    expose:
      - "80"
{% if not zammad_standalone %}
    ports:
      - 127.0.0.1:8000:80
{% endif %}
    logging: *default-logging
    environment:
      NGINX_SERVER_SCHEME: "https"
      VIRTUAL_HOST: "{{ zammad_domain }}"
      LETSENCRYPT_HOST: "{{ zammad_domain }}"
{% if zammad_standalone %}
      LETSENCRYPT_EMAIL: "{{ zammad_letsencrypt_email }}"

  zammad-elasticsearch:
    image: "{{ zammad_image_elasticsearch }}"
    restart: "{{ zammad_docker_restart_policy }}"
    environment:
      - discovery.type=single-node
    volumes:
      - elasticsearch-data:/usr/share/elasticsearch/data
    logging: *default-logging

  zammad-postgresql:
    image: "{{ zammad_image_zammad_postgresql }}"
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - postgresql-data:/var/lib/postgresql/data
      - zammad-data:/opt/zammad
      - zammad-backup:/var/tmp/zammad:ro
    environment:
      POSTGRES_PASSWORD: "{{ zammad_db_password }}"
      POSTGRES_USER: "{{ zammad_db_username }}"
      POSTGRES_DB: "{{ zammad_db_name }}"
    logging: *default-logging
{% endif %}

  zammad-init:
    image: "{{ zammad_image_zammad }}"
    command: ["zammad-init"]
    depends_on:
{% if zammad_standalone %}
      - zammad-postgresql
      - zammad-elasticsearch
{% endif %}
      - zammad-memcached
    restart: on-failure
    logging: *default-logging
    volumes:
      - zammad-data:/opt/zammad
    environment:
      POSTGRESQL_PASS: "{{ zammad_db_password }}"
      POSTGRESQL_USER: "{{ zammad_db_username }}"
      POSTGRESQL_DB: "{{ zammad_db_name }}"
{% if not zammad_standalone %}
      POSTGRESQL_HOST: "{{ zammad_db_host }}"
      POSTGRESQL_PORT: "{{ zammad_db_port }}"
      POSTGRESQL_DB_CREATE: "{{ zammad_db_create | bool | ternary ('true', 'false')}}" # this is a string not a boolean, and the only valid true value is "true"
      ELASTICSEARCH_ENABLED: "{{ zammad_es_enabled | bool | ternary('true', 'false') }}" # this is a string not a boolean, and the only false value is "false"
{% if zammad_es_enabled %}
      ELASTICSEARCH_HOST: "{{ zammad_es_host }}"
      ELASTICSEARCH_SCHEMA: "{{ zammad_es_schema }}"
      ELASTICSEARCH_PORT: "{{ zammad_es_port }}"
      ELASTICSEARCH_SCHEMA: "{{ zammad_es_schema }}"
      ELASTICSEARCH_NAMESPACE: "{{ zammad_es_namespace }}"
      ELASTICSEARCH_REINDEX: "{{ zammad_es_reindex  | bool | ternary('true', 'false') }}"
      ELASTICSEARCH_SSL_VERIFY: "{{ zammad_es_ssl_verify  | bool | ternary('true', 'false') }}"
{% endif %}
{% endif %}

  zammad-memcached:
    image: "{{ zammad_image_memcached }}"
    restart: "{{ zammad_docker_restart_policy }}"
    command: ["-m {{ zammad_memcached_size }}"]
    logging: *default-logging

  zammad-railsserver:
    image: "{{ zammad_image_zammad }}"
    command: ["zammad-railsserver"]
    depends_on:
      - zammad-memcached
{% if zammad_standalone %}
      - zammad-postgresql
      - zammad-elasticsearch
{% endif %}
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - zammad-data:/opt/zammad
    logging: *default-logging

  zammad-scheduler:
    image: "{{ zammad_image_zammad }}"
    command: ["zammad-scheduler"]
    depends_on:
      - zammad-memcached
      - zammad-railsserver
{% if zammad_standalone %}
      - zammad-elasticsearch
      - zammad-postgresql
{% endif %}
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - zammad-data:/opt/zammad
    logging: *default-logging

  zammad-websocket:
    image: "{{ zammad_image_zammad }}"
    command: ["zammad-websocket"]
    depends_on:
      - zammad-railsserver
{% if zammad_standalone %}
      - zammad-postgresql
{% endif %}
      - zammad-memcached
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - zammad-data:/opt/zammad
    logging: *default-logging

{% if zammad_monitoring_enabled %}
{% if zammad_standalone %}
  zammad-postgresql-exporter:
    image: "{{ zammad_image_postgresql_exporter }}"
    restart: "{{ zammad_docker_restart_policy }}"
    depends_on:
      - zammad-postgresql
    depends_on:
      - zammad-postgresql
    environment:
      DATA_SOURCE_NAME: "postgresql://{{ zammad_db_username }}:{{ zammad_db_password }}@zammad-postgresql:5432/postgres?sslmode=disable"
    ports:
      - "127.0.0.1:9187:9187"
    logging: *default-logging
{% endif %}

  cadvisor:
    image: "{{ zammad_image_cadvisor }}"
    volumes:
      - /:/rootfs:ro
      - /var/run:/var/run:ro
      - /sys:/sys:ro
      - /var/lib/docker/:/var/lib/docker:ro
    ports:
      - "127.0.0.1:8080:8080"
    restart: "{{ zammad_docker_restart_policy }}"
    deploy:
      mode: global
    logging: *default-logging

  zammad-exporter:
    image: "{{ zammad_image_zammad_exporter }}"
    depends_on:
      - zammad-nginx
    restart: "{{ zammad_docker_restart_policy }}"
    ports:
      - "127.0.0.1:9390:9390"
    environment:
      ZAMMAD_TOKEN: "{{ zammad_monitoring_token }}"
      ZAMMAD_HOST: "http://zammad-nginx:80"
      ZAMMAD_EXPORTER_PORT: 9390
    logging: *default-logging
{% endif %}

  metamigo-api:
    image: "{{ zammad_image_metamigo }}"
    restart: "{{ zammad_docker_restart_policy }}"
    command: ["api"]
    expose:
      - "3001"
    ports:
      - 127.0.0.1:8001:3001
    environment: *common-metamigo-variables
    volumes:
      - /var/lib/cdr/signald:/signald
      - /var/lib/cdr/baileys:/baileys
    logging: *default-logging

  metamigo-frontend:
    image: "{{ zammad_image_metamigo }}"
    restart: "{{ zammad_docker_restart_policy }}"
    command: ["frontend"]
    expose:
      - "3000"
{% if not zammad_standalone %}
    ports:
      - "127.0.0.1:8002:3000"
{% endif %}
    environment:
      <<: *common-metamigo-variables
{% if zammad_standalone %}
      VIRTUAL_HOST: "{{ metamigo_frontend_domain }}"
      VIRTUAL_PORT: 3000
      LETSENCRYPT_HOST: "{{ metamigo_frontend_domain }}"
      LETSENCRYPT_EMAIL: "{{ zammad_letsencrypt_email }}"
{% endif %}
    logging: *default-logging

  metamigo-worker:
    image: "{{ zammad_image_metamigo }}"
    restart: "{{ zammad_docker_restart_policy }}"
    command: ["worker"]
    environment: *common-metamigo-variables
    logging: *default-logging

{% if zammad_standalone %}
  metamigo-postgresql:
    image: "{{ zammad_image_metamigo_postgresql }}"
    restart: "{{ zammad_docker_restart_policy }}"
    volumes:
      - metamigo-data:/var/lib/postgresql/data
    environment:
      POSTGRES_PASSWORD: "{{ metamigo_root_db_password }}"
      POSTGRES_USER: "{{ metamigo_root_db_username }}"
      POSTGRES_DB: "{{ metamigo_db_name }}"
    expose:
      - "5432"
    ports:
      - 127.0.0.1:5432:5432
    logging: *default-logging
{% endif %}

{% if zammad_protonmail_enabled %}
  protonmail:
    image: "{{ zammad_image_protonmail }}"
    restart: "{{ zammad_docker_restart_policy }}"
    user: "1000:1000"
    environment:
      HOME: "/root"
    volumes:
      - /var/lib/cdr/protonmail:/root
    ports:
      - "1025:25"
      - "1143:143"
    logging: *default-logging
{% endif %}

{% if label_studio_enabled %}
  label-studio:
    image: "{{ label_studio_docker_image }}"
    restart: "{{ zammad_docker_restart_policy }}"
{% if not zammad_standalone %}
    ports:
      - "127.0.0.1:8004:8080"
{% endif %}
    environment:
      DJANGO_DB: default
      LABEL_STUDIO_DISABLE_SIGNUP_WITHOUT_LINK: "true"
      POSTGRE_NAME: "{{ label_studio_db_name }}"
      POSTGRE_USER: "{{ label_studio_db_username }}"
      POSTGRE_PASSWORD: "{{ label_studio_db_password }}"
      POSTGRE_PORT: "{{ label_studio_db_port }}"
      POSTGRE_HOST: "{{ label_studio_db_host }}"
{% if zammad_standalone %}
      VIRTUAL_HOST: "{{ label_studio_frontend_domain }}"
      VIRTUAL_PORT: 8080
      LETSENCRYPT_HOST: "{{ label_studio_frontend_domain }}"
      LETSENCRYPT_EMAIL: "{{ zammad_letsencrypt_email }}"
    logging: *default-logging
{% endif %}
{% endif %}

  signald:
    image: "{{ zammad_image_signald }}"
    restart: "{{ zammad_docker_restart_policy }}"
    user: "1000:1000"
    volumes:
      - /var/lib/cdr/signald:/signald
    logging: *default-logging

volumes:
{% if zammad_standalone %}
  elasticsearch-data:
    driver: local
  postgresql-data:
    driver: local
  zammad-backup:
    driver: local
  metamigo-data:
    driver: local
{% endif %}
  zammad-data:
    driver: local

{% if zammad_standalone %}
networks:
  default:
    external:
      name: "nginx-proxy"
{% endif %}
